<template>
  <div class="w-full background1 flex flex-col h-screen gap-[3vw]">
    <div class="bg-[white] rounded-b-full">
      <div class="bg-white grid grid-cols-3 px-[3.735vw] h-[11.74vw]">
        <div></div>
        <div
          class="text-center text-[4.1vw] text-gray-600 flex items-center justify-center"
        >
          {{ $t("account") }}
        </div>
        <div class="flex justify-end gap-2 place-items-center">
          <div @click="onNavigateToPage(ROUTES.ACCOUNT.PASSWORD)">
            <img
              class="max-w-[6vw]"
              :src="
                getAssetImage(
                  'assets/theme/light_flexible_1/mobile/images/setting.png'
                )
              "
            />
          </div>
          <div>
            <language-component />
          </div>
        </div>
      </div>
      <div class="profile p-[3.735vw] bg-white">
        <div class="flex items-center">
          <div class="w-full">
            <div class="flex gap-5 w-full">
              <div class="profileImage">
                <img
                  class="max-w-[18vw]"
                  :src="
                    getAssetImage(
                      'assets/theme/light_flexible_1/mobile/images/contactUsPage/userProfile.png'
                    )
                  "
                />
              </div>
              <div v-if="authentication" class="font-bold text-gray-600 w-full">
                <div class="text-[4.1vw]">{{ username }}</div>
                <div class="text-[3vw]">
                  <template v-if="walletList.length > 1">
                    <div v-for="(wallet, index) in walletList" :key="index">
                      <span
                        class="w-[63px] h-[14px] font-normal text-xs leading-[14px] whitespace-nowrap"
                        >{{ wallet.getWalletNameForDisplay() }}</span
                      >
                      <div
                        class="flex flex-row justify-between items-end p-0 gap-11 w-full h-[28px]"
                      >
                        <span class="h-[28px] font-bold text-xl leading-7">{{
                          wallet.getBetCreditForDisplay()
                        }}</span>
                        <div class="m-account-item">
                          <div class="m-account-currency">{{ currency }}</div>
                          <icons
                            :is-refresh="true"
                            :class="{ 'fa-spin': isLoading }"
                            class="refresh_icon"
                            @click="getMultiWallets"
                          />
                        </div>
                      </div>
                    </div>
                  </template>
                  <template v-else>
                    <div class="flex items-center">
                      <span class="mr-[2vw]">{{ currency }}</span>
                      <button type="button" @click="getMultiWallets">
                        <icons :is-refresh="true" />
                      </button>
                    </div>
                    <span class="m-amount-number balance-amount">{{
                      mainBalanceForDisplay
                    }}</span>
                  </template>
                </div>
              </div>
              <div v-else class="flex items-center font-bold text-black">
                <span class="text-[4.1vw]">{{ $t(username) }}</span>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="card bg-white px-[3.735vw] pb-2 rounded-b-3xl py-[2.665vw]">
        <div class="shadowBox rounded-xl">
          <div class="flex justify-around relative h-[17.05vw]">
            <div
              class="flex items-center justify-center space-x-0 border-to-center"
              @click="onNavigateToPage(BET_HISTORY_ROUTES.SPORT)"
              :id = "`${ID.USER_CENTER.BET_HISTORY}`"

            >
              <div class="shrink-0 vip pointer-events-none">
                <img
                  class="menu-above-icon"
                  :src="
                    getAssetImage(
                      'assets/theme/light_flexible_1/mobile/images/vip.png'
                    )
                  "
                  alt="ChitChat Logo"
                />
              </div>
              <div>
                <div class="text-[4.1vw] font-medium text-black pointer-events-none">
                  {{ $t("bet_history") }}
                </div>
              </div>
            </div>
            <div
              v-if="isAllowPromotionTab"
              class="flex items-center justify-center"
              @click="onNavigateToPage('/transaction-history/my-promotion')"
              :id = "`${ID.USER_CENTER.PROMOTION}`"
            >
              <div class="shrink-0 gift pointer-events-none">
                <img
                  class="menu-above-icon"
                  :src="
                    getAssetImage(
                      'assets/theme/light_flexible_1/mobile/images/gift.png'
                    )
                  "
                  alt="ChitChat Logo"
                />
              </div>
              <div>
                <div class="text-[4.1vw] font-medium text-black pointer-events-none">
                  {{ $t("my_promotion") }}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="wallet">
          <div class="grid grid-cols-4 gap-5 place-items-center py-[3.735vw] items-baseline">
            <div
              v-if="checkPlayer"
              class="flex flex-col items-center"
              @click="onNavigateToPage('/deposit')"
              :id = "`${ID.USER_CENTER.DEPOSIT}`"
            >
              <img
                class="menu-icon pointer-events-none"
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/mobile/images/wallet.png'
                  )
                "
              />
              <p class="text-[3.7vw] text-center pointer-events-none">{{ $t(`deposit${isBhinbhin}`) }}</p>
            </div>
            <div
              v-if="checkPlayer"
              class="flex flex-col items-center"
              @click="onNavigateToPage('/withdrawal')"
              :id = "`${ID.USER_CENTER.WITHDRAW}`"
            >
              <img
                class="menu-icon pointer-events-none"
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/mobile/images/wallet2.png'
                  )
                "
              />
              <p class="text-[3.7vw] text-center pointer-events-none">{{ $t("withdrawal") }}</p>
            </div>
            <div
              v-if="checkPlayer"
              class="flex flex-col items-center"
              @click="onNavigateToPage('transaction-history/deposit')"
              :id = "`${ID.USER_CENTER.TRANSACTION_HISTORY}`"
            >
              <img
                class="menu-icon pointer-events-none"
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/mobile/images/walletTransfer.png'
                  )
                "
              />
              <p class="text-[3.7vw] text-center pointer-events-none">{{ $t("transaction") }}</p>
            </div>
            <div
              class="flex flex-col items-center"
              @click="onNavigateToPage('/wallet')"
              :id = "`${ID.USER_CENTER.WALLET}`"
            >
              <img
                class="menu-icon pointer-events-none"
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/mobile/images/walletSetting.png'
                  )
                "
              />
              <p class="text-[3.7vw] text-center pointer-events-none">{{ $t("balance") }}</p>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="flex flex-col px-[3.735vw] bg-white">
      <div
        class="hScreen flex items-center justify-between border-b-[1px]"
        @click="onNavigateToPage('/account')"
        :id = "`${ID.USER_CENTER.ACCOUNT}`"
      >
        <div class="flex items-center gap-4 pointer-events-none">
          <img
            class="max-w-[6vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/userProfile.png'
              )
            "
          />
          <span class="text-[3.7vw] pointer-events-none">{{ $t("profile") }}</span>
        </div>
        <div>
          <img
            class="max-w-[1.5vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/arrowRight.png'
              )
            "
          />
        </div>
      </div>
      <div
        v-if="referralEnabled && !isV2ReferralEnabled"
        class="hScreen flex items-center justify-between border-b-[1px]"
        @click="onNavigateToPage('/referral')"
        :id = "`${ID.USER_CENTER.REFERRAL}`"
      >
        <div class="flex items-center gap-4 pointer-events-none">
          <img
            class="max-w-[6vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/friends.png'
              )
            "
          />
          <span class="text-[3.7vw] pointer-events-none">{{ $t("referral") }}</span>
        </div>
        <div class="flex items-center">
          <div class="w-[109.19px] h-[48.41px]">
            <img
              :src="
                getAssetImage(
                  'assets/theme/light_flexible_1/mobile/images/adverstise.png'
                )
              "
              alt=""
            />
          </div>
          <img
            class="max-w-[1.5vw] w-[5.84px] h-[10.22px]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/arrowRight.png'
              )
            "
          />
        </div>
      </div>
      <div
        v-if="isReferralV2Enabled  && isShowReferralPage"
        class="hScreen flex items-center justify-between border-b-[1px]"
        @click="onNavigateToPage('/referral-v2/information')"
        :id = "`${ID.USER_CENTER.REFERRAL}`"
      >
        <div class="flex items-center gap-4 pointer-events-none">
          <img
            class="max-w-[6vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/friends.png'
              )
            "
          />
          <span class="text-[3.7vw] pointer-events-none">{{ $t("referral") }}</span>
        </div>
        <div class="flex items-center">
          <div class="w-[109.19px] h-[48.41px]">
            <img
              :src="
                getAssetImage(
                  'assets/theme/light_flexible_1/mobile/images/adverstise.png'
                )
              "
              alt=""
            />
          </div>
          <img
            class="max-w-[1.5vw] w-[5.84px] h-[10.22px]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/arrowRight.png'
              )
            "
          />
        </div>
      </div>
      <div
        v-if="!agentCooperation.IsHidden"
        class="hScreen flex items-center justify-between border-b-[1px]"
        @click="onNavigateToPage('/agent-cooperation')"
      >
        <div class="flex items-center gap-4">
          <img
            class="max-w-[6vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/agent.png'
              )
            "
          />
          <span class="text-[3.7vw]">{{ $t("agent_cooperation") }}</span>
        </div>
        <div>
          <img
            class="max-w-[1.5vw] w-[5.84px] h-[10.22px]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/arrowRight.png'
              )
            "
          />
        </div>
      </div>
      <div
        class="flex items-center justify-between border-b-[1px] hScreen"
        @click="onNavigateToPage('/transaction-History/winlose')"
        :id = "`${ID.USER_CENTER.TRANSACTION_HISTORY}`"
      >
        <div class="flex items-center gap-4 pointer-events-none">
          <img
            class="max-w-[6vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/mail.png'
              )
            "
          />
          <span class="text-[3.7vw] pointer-events-none">{{ $t("statement") }}</span>
        </div>
        <div>
          <img
            class="max-w-[1.5vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/arrowRight.png'
              )
            "
          />
        </div>
      </div>
      <div
        class="flex items-center justify-between hScreen"
        @click="onNavigateToPage('/messages')"
        :id = "`${ID.USER_CENTER.MESSAGE}`"
      >
        <div class="flex items-center gap-4 pointer-events-none">
          <img
            class="max-w-[6vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/mail.png'
              )
            "
          />
          <span class="text-[3.7vw] pointer-events-none">{{ $t("messages") }}</span>
          <MessagesMessageCount
            v-if="unreadInfo && unreadInfo.TotalCount"
            :count="unreadInfo.TotalCount"
            :is-unread="true"
            class="!ml-1"
          ></MessagesMessageCount>
        </div>
        <div>
          <img
            class="max-w-[1.5vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/arrowRight.png'
              )
            "
          />
        </div>
      </div>
    </div>
    <div class="flex flex-col px-[3.735vw] bg-white">
      <div
        v-if="authentication"
        class="flex items-center justify-between hScreen"
        @click="onLogout"
      >
        <div class="flex items-center gap-4">
          <img
            class="max-w-[6vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/exclamationMark.png'
              )
            "
          />
          <span class="text-[3.7vw]">{{ $t("logout") }}</span>
        </div>
        <div>
          <img
            class="max-w-[1.5vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/arrowRight.png'
              )
            "
          />
        </div>
      </div>
      <div
        v-else
        class="flex items-center justify-between hScreen"
        @click="onNavigateToPage('/login')"
      >
        <div class="flex items-center gap-4">
          <img
            class="max-w-[6vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/exclamationMark.png'
              )
            "
          />
          <span class="text-[3.7vw]">{{ $t("capital_login") }}</span>
        </div>
        <div>
          <img
            class="max-w-[1.5vw]"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/arrowRight.png'
              )
            "
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import LanguageComponent from "./components/languageComponent.client.vue";
import {
  useLanguageComponent,
  useHeaderComponent,
} from "@/composables/useTheme";
import { store } from "@/store";
import useBalanceInfo from "@/composables/useBalanceInfo";
import useMenu from "@/composables/useMenu";
import { Wallet } from "~~/models/common/wallet";
import { ID } from "~~/utils/constants";

export default defineComponent({
  name: "Profile",
  components: {
    LanguageComponent,
  },
  setup() {
    const { $t } = useNuxtApp();
    const router = useRouter();
    const activeNames = ref([]);
    const authentication = computed(() => store.state.auth);
    const username = computed(() =>
      store.state.auth ? store.state.username : $t("anonymous_user")
    );
    const { logout, referralEnabled, agentCooperation, isAllowPromotionTab, isReferralV2Enabled } =
      useHeaderComponent();
    const onLogout = () => {
      logout();
    };
    const { getBalance, currency, balanceUser, wallets, isLoading,  mainBalanceForDisplay, getMultiWallets, } =
      useBalanceInfo();
      const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
    const {
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
    } = useLanguageComponent();
    const isBSI = computed(() => !store.state.auth);
    const onNavigateToPage = (url: string) => {
      if (isBSI.value) {
        router.push("/login");
        return;
      }
      router.push(url);
    };
    const { getAssetImage, isBhinbhin } = commonHelper;
    const { checkPlayer } = useMenu();
    const walletList = computed(() => wallets.value.map((w) => new Wallet(w)));
    const { fetchMessages, unreadInfo } = useMessage();
    const route = useRoute();
    onMounted(() => {
      if (!route.fullPath.includes("messages")) {
        fetchMessages();
      }
    });
    return {
      getBalance,
      activeNames,
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
      isBSI,
      onLogout,
      onNavigateToPage,
      username,
      referralEnabled,
      currency,
      balanceUser,
      authentication,
      getAssetImage,
      checkPlayer,
      agentCooperation,
      isAllowPromotionTab,
      isLoading,
      walletList,
      isReferralV2Enabled,
      mainBalanceForDisplay,
      getMultiWallets,
      isShowReferralPage,
      unreadInfo,
      isBhinbhin,
    };
  },
});
</script>

<style lang="scss" scoped>
.el-collapse {
  --el-collapse-content-bg-color: none;
  --el-collapse-header-bg-color: none;
  border: none;

  :deep(.el-collapse-item__arrow) {
    font-weight: bold;
    color: var(--text);
  }
}

.icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 50%;
    object-fit: contain;
  }

  height: 21.83px;
  width: 21.83px;
  border-radius: 50%;
  background-color: rgba(255, 255, 255);
}
.m-account-currency {
  @apply text-sm leading-4 font-normal;
  color: var(--text);
}
.m-account-item {
  @apply flex items-center justify-center p-0 gap-1 w-[47px] h-[16px];
}
</style>
<style>
.m-profile-menu-item {
  border-bottom: 0.5px solid #393c68;
}

.m-profile-menu-item:last-child {
  border-bottom: none;
}

.m-angle-right-container {
  height: 21.83px;
  width: 21.83px;
  display: flex;
  justify-content: center;
  color: var(--textBtn);
}

.m-angle-right-container svg {
  font-size: 16.31px;
}

.profile-menu-title {
  font-size: 15.82px;
  color: var(--textBtn);
  margin-left: 8.73px;
}

.el-collapse-item__arrow {
  display: none;
}

.el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: unset;
}

.el-collapse-item .m-language-collapse {
  transition: transform 0.3s ease-in-out;
}

.el-collapse-item.is-active .m-language-collapse {
  transform: rotate(-180deg);
}

.lang-wr-option-container {
  padding-top: 4.87px;
  padding-bottom: 4.87px;
  margin-top: 18px !important;
  margin-bottom: 27px !important;
}

.m-profile-item-btn {
  font-size: 15.82px;
  color: var(--textBtn);
  border: unset;
  padding: var(--padding-x);
  height: 52.31px;
  border-radius: 0.5rem;
}

.padding-y {
  padding-top: 12.25px;
  padding-bottom: 12.25px;
}

.m-margin-unset {
  margin-top: unset !important;
}

.shadowBox {
  box-shadow: rgba(99, 99, 99, 0.2) 0px 2px 8px 0px;
}

.menu-above-icon {
  max-width: 14vw;
}

.menu-icon {
  max-width: 10vw;
}

.hScreen {
  height: 14vw;
}
</style>
